import base64
import json
import threading
import urllib
from http.server import HTTPServer, BaseHTTPRequestHandler

import requests

from resources.lib.compatibility import WebSocketApp, encode_utf, decode_utf
from resources.lib.const import SETTINGS, URL, LANG, ROUTE
from resources.lib.gui.directory_items import InfoDialog
from resources.lib.gui.renderers.media_list_renderer import MediaListRenderer
from resources.lib.kodilogging import service_logger
from resources.lib.routing.router import router
from resources.lib.services import ThreadService
from resources.lib.storage.settings import settings
from resources.lib.utils.kodiutils import get_string
from resources.lib.utils.url import Url
from resources.lib.wrappers.http import Http


class Proxy(BaseHTTPRequestHandler):
    def do_GET(self):
        try:
            # Send response status code
            self.send_response(200)

            # Send message back to client
            print("REQUEST", self.path)
            fragments = self.path.split('/')
            print(fragments, fragments[-2])
            if fragments[-2] == 'link':
                link_id = fragments[-1]
                decoded_url = base64.b64decode(link_id)
                url = decoded_url.decode("utf-8")
                print("REQUESTED LINK FOR ID", url)
                message = decoded_url
                stream = requests.request("GET", url, headers=self.headers, stream=True)
                for key, value in stream.headers.items():
                    print("HEADER", key, value)
                    self.send_header(key, value)
                self.send_response(200)
                self.end_headers()
                response = b""
                for data in stream.iter_content():
                    response = response + data
                    self.wfile.write(data)

                print("response", response)
            else:
                message = bytes("pomoc jsem utlacovanej", 'utf8')
                # Send headers
                self.send_header('Content-type', 'text/plain; charset=utf-8')
                self.send_header('Content-length', str(len(message)))
                self.end_headers()
                print("SENDING RESPONSE", message)
                # Write content as utf-8 data
                self.wfile.write(message)
            return
        except Exception as e:
            print("ERROR", e)
            self.send_response(403)
            self.end_headers()
        finally:
            return


class ProxyService(ThreadService):
    def __init__(self):
        super(ProxyService, self).__init__()
        self.server = HTTPServer(('localhost', 8093), Proxy)

    def stop(self):
        self.server.server_close()
        self.server.shutdown()
        super(ProxyService, self).stop()

    def start(self):
        t = threading.Thread(target=self._start)
        t.start()
        self.threads.append(t)

    def _start(self):
        print("STARTING WEB SERVER PROXY")
        self.server.serve_forever()
